%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%							%
% Übung: Familiendatenbank				%
% Formuliere für die jeweilige Anfrage ein Prädikat.	%
%							%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- ensure_loaded('01_familienstammbaum').

% Schreibe ein Prädikat mutter/2, welches jemandes Mutter angibt.

% Erläuterung
% Das Prädikat mutter/2 soll ein X entgegen nehmen und überprüfen, ob X die Mutter von Y ist. Hierfür muss festgestellt werden, dass X feminin, als auch ein Elternteil von Y ist. 

% X ist Mutter von Y
mutter(X,Y) :-
    fem(X),  				% X ist feminin
    et(X,Y). 				% und ein Elternteil von Y
%____________________________________________________________________________________________________________________________________________________________
    
% Schreibe ein Prädikat vater/2, welches jemandes Vater angibt.

% Erläuterung
% Das Prädikat vater/2 soll ein X entgegen nehmen und überprüfen, ob X der Vater von Y ist. Hierfür muss festgestellt werden, dass X maskulin, als auch ein Elternteil von Y ist.

% X ist Vater von Y
vater(X,Y):-
	masc(X), 			% X ist maskulin
	et(X,Y). 			% und ein Elternteil von Y 	
%____________________________________________________________________________________________________________________________________________________________

% Schreibe ein Prädikat tochter/2, welches jemandes Tochter angibt.

% Erläuterung
% Das Prädikat tochter/2 soll ein X entgegen nehmen und überprüfen, ob X die Tochter von Y ist. Hierfür muss festgestellt werden, dass X feminin, als auch das Y ein Elternteil von X ist.

% X ist Tochter von Y
tochter(X,Y):-
	fem(X),   			% X ist feminin
	et(Y,X).  			% und Y ist ein Elternteil von X
	
%____________________________________________________________________________________________________________________________________________________________

% Schreibe ein Prädikat sohn/2, welches jemandes Sohn angibt.

% Erläuterung
% Das Prädikat vater/2 soll ein X entgegen nehmen und überprüfen, ob X der Vater von Y ist. Hierfür muss festgestellt werden, dass X maskulin, als auch ein Elternteil von Y ist.

% X ist Sohn von Y
sohn(X,Y):-
	masc(X),  			% X ist maskulin
	et(Y,X).  			% und Y ist ein Elternteil von X
	
%____________________________________________________________________________________________________________________________________________________________

% Schreibe ein Prädikat schwester/2, welches jemandes Schwester angibt.

% Erläuterung
% Das Prädikat schwester/2 soll ein X entgegen nehmen und überprüfen, ob X die Schwester von Y ist. Hierfür muss festgestellt werden, dass X feminin ist, das Geschlecht von Y ist irrelevant. Desweiteren müssen X und Y mindestens ein gleiches Elternteil haben. Zusätzlich stellt es sicher, dass X nicht die Schwester von sich selbst ist. 
	
% X ist Schwester von Y und X ist nicht Y
schwester(X,Y):-
	fem(X),   			% X ist feminin
	et(Z,X), 		 	% X hat das Elternteil Z
	et(Z,Y),  			% und Y hat auch das Elternteil Z. Geschlecht von Y ist egal!
	% falls man nicht Schwester von sich selbst sein soll:
	X \= Y.
%____________________________________________________________________________________________________________________________________________________________

% Schreibe ein Prädikat bruder/2, welches jemandes Bruder angibt.

% Erläuterung
% Das Prädikat bruder/2 soll ein X entgegen nehmen und überprüfen, ob X der Bruder von Y ist. Hierfür muss festgestellt werden, dass X maskulin ist, das Geschlecht von Y ist irrelevant. Desweiteren müssen X und Y mindesrens ein gleiches Elternteil haben. Zusätzlich stellt es sicher, dass Y nicht der Bruder von sich selbst ist.

% X ist Bruder von Y und X ist nicht Y
bruder(X,Y):-
	masc(X),  			% X ist maskulin
	et(Z,X),  			% und X hat das Elternteil Z
	et(Z,Y),  			% und Y hat das selbe Elternteil Z. Geschlecht von Y ist egal!
	% falls man nicht Bruder von sich selbst sein soll: 
	X \= Y.   		
%____________________________________________________________________________________________________________________________________________________________

% Schreibe ein Prädikat opa/2, welches jemandes Großvater angibt.

% Erläuterung
% Das Prädikat opa/2 soll ein X entgegen nehmen und überprüfen, ob X der Großvater von Y ist. Hierfür muss festgestellt werden, dass X maskulin ist. Desweiteren muss X ein Elternteil von Z sein und Z wiederrum ein Elternteil von Y.
	
% X ist Opa von Y.
grossvater(X,Y):-
	masc(X),    			% X, der Opa, ist maskulin
	et(X,Z),    			% und X ist Elternteil von Z (Z ist ein Mensch der Generation zwischen X und Y).
	et(Z,Y).   	 		% und Z ist Elternteil von Y.
