%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Formuliere Fakten und Regeln         (Quelle: Moodle)                                 %
%                                                                                       %
% Druecke folgende Fakten und Regeln in Prolog aus:                                     %
% Hier gibt es kein richtig oder falsch, die Loesungen gelten lediglich als Beispiel.   %
% 1 Lena ist hungrig.                                                                   %
% 2 Lena ist Ottos Mutter.                                                              %
% 3 Lena mag alle, die ihr Schokolade schenken.                                         %
% 4 Lena mag alle, die gut singen koennen und gut kochen.                               %
% 5 Lena mag alle, die ihr Schokolade oder Kekse schenken.                              %
% 6 Alle Menschen sind sterblich.                                                       %
% 7 Sokrates ist sterblich.                                                             %
% 8 Eine Tochter einer Person ist ein weibliches Kind dieser Person.                    %
% 9 Alle Hunde moegen Wurst.                                                            %
% 10 Pluto mag alles, was Mickey ihm gibt.                                              %
%                                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%% Loesung

hungrig(lena).                % X ist hungrig

ist_mutter_von(lena,otto).    % X ist die Mutter von Y

% Da Jemand mit grossem J anfaengt, ist es eine Variable (so wie X). 
% Jemand wird als freie Variable also mit allen Personen unifiziert, 
% die lena schokolade schenken.
% Das gleiche gilt fuer alle Praedikate weiter unten
mag(lena,Jemand) :- schenken(Jemand,lena,schokolade).         % Wenn Jemand Y Z schenkt, dann mag Y Jemand.

mag(lena,Jemand) :- gut_singen(Jemand), gut_kochen(Jemand).   % Wenn Jemand gut singen und gut kochen kann, dann mag X Jemand.

mag(lena,Jemand) :- schenken(Jemand,lena,schokolade);         % Wenn Jemand Y Z schenkt 
                  schenken(Jemand,lena,kekse).                % oder wenn Jemand Y S schenkt, dann mag Y Jemand.
                  
sterblich(Jemand) :- mensch(Jemand).                          % Wenn Jemand ein Mensch ist, dann ist Jemand sterblich.

sterblich(sokrates).                                          % X ist sterblich.

ist_tochter_von(Jemand,Person) :- weiblich(Jemand), kind(Jemand,Person). % Wenn Jemand weiblich und Jemand das Kind von Person ist, dann ist Jemand die Tochter von Person. 

mag(Jemand,wurst) :- hund(Jemand).                            % Wenn Jemand ein Hund ist, dann mag Jemand Wurst.

mag(pluto,Etwas) :- geben(mickey,Etwas,pluto).                % Wenn X Y Etwas gibt, dann mag Y Etwas.
